/* Emperor - an X windows strategy game for 1-6 players
   Copyright (C) 1998 Frank Rustemeyer.
   This file is part of the Emperor package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   If you have changes and you want them to be included in a future
   release of Emperor, please e-mail them to mambres@mud.tap.de.

   This file is for global definitions and macros.

   98/11/30, Frank Rustemeyer <mambres@mud.tap.de>: Released.
   99/01/29, Frank Rustemeyer <mambres@mud.tap.de>: Added language support.
*/

// Default language is German. If you want an English version, uncomment
// the following line:
// #define ENGLISH

#ifndef SX
// *********************************************************************
// *********  Constants which can be changed to customize application **

#define SX 70
#define SY 70

#define BEGINNSTAEDTE 3


// *********************************************************************
// *********************  Constants/Macros for better readability ******

#define WINDOWX 620
#define WINDOWY 430

// symbolic constants
//     invalidate main window
#define FULL 1
#define MAP 2
//     fortification constant
#define FORTIFY 100

// Miscellaneous
//     checks if c is a field on the map
#define ONMAP(c) (((c).x>=0) && ((c).x<SX) && ((c).y>=0) && ((c).y<SY))
//     random number 0...n
#define RANDOM(n) (rand() % (n))

#include <time.h>                       
#define RANDOMIZE() (srand(time(NULL)))

// itoa for g++:
#define itoa(a,b,c) sprintf(b, "%d", a);

//     loops a coordinate from x,y to x,y step s:
#define LOOP(c,x1,y1,x2,y2,s) for((c).x = (x1); (c).x <= (x2); (c).x+=s) \
			      for((c).y = (y1); (c).y <= (y2); (c).y+=s)
//     signed loop, can loop forward (s=1) and backward (s=-1):
#define SLOOP(c,x1,y1,x2,y2,s) for((c).x = (x1); (s)*(x2) - (s)*(c).x >= 0; (c).x+=s) \
                               for((c).y = (y1); (s)*(y2) - (s)*(c).y >= 0; (c).y+=s)

//     deletes all members of a list:
#define DELETELIST(x) while(x.root) x.remove(x.root)
//     returns first list member or NULL if list is empty:
#define FIRSTMEMBER(x) ( (x).root ? (x).root->first() : (x).root )

// List types
#define CITIES 1
#define ARMIES 2

// Unit types
#define UNIT_TYPES 9

#define EXIT 0
#define INFANTRIE 1
#define PANZER	2
#define FLIEGER	3
#define UBOOT 4
#define SCHNELLBOOT 5
#define FREGATTE 6
#define SCHLACHTSCHIFF 7
#define TRANSPORTER 8
#define MINENLEGER 9
                 
#endif
